#include "StdAfx.h"
#include ".\adddlg.h"
#include "resource.h"
#include <algorithm>
#include "cs_conv.h"

#define ARRAY_SIZE_OF(x) (sizeof(x)/sizeof((x)[0]))

//*******************************************************************
// 
//*******************************************************************

CAddDlg::CAddDlg(void)
: CDlg(IDD_ADD)
{
}

CAddDlg::~CAddDlg(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************

BOOL CAddDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM /*lParam*/)
{
	if( (uMsg == WM_COMMAND)
		&& (wParam == MAKEWPARAM(IDC_TIME, EN_CHANGE)) )
	{
		SetEnable(IDOK, (GetItemTextInt(IDC_TIME) > 0));
		return TRUE;
	}
	return FALSE;
}

BOOL CAddDlg::InitDlgCtrl()
{
	std::string str;

	::UnicodeToSJIS(m_pInfo->str.c_str(), str);

	SetItemText(IDC_TIME, (m_pInfo->nIdle/60));
	SetCombo(IDC_STATE, &STATUS_STRINGS[1], STATUS_STRINGS_NUM-1, m_pInfo->nState);
	SetCombo(IDC_DIR, POS_STRINGS, POS_STRINGS_NUM, m_pInfo->nPos);
	SetItemText(IDC_STR, str.c_str());

	SetEnable(IDOK, (m_pInfo->nIdle/60 > 0));
	return TRUE;
}

BOOL CAddDlg::GetDlgCtrlValue()
{
	int nIdle;
	std::string str;

	nIdle = GetItemTextInt(IDC_TIME);
	if( nIdle <= 0 ) return FALSE;

	m_pInfo->nIdle = nIdle * 60;
	m_pInfo->nState = GetComboCurSel(IDC_STATE, 0);
	m_pInfo->nPos = GetComboCurSel(IDC_DIR, 0);
	GetItemText(IDC_STR, str);

	::SJIStoUnicode(str.c_str(), m_pInfo->str);

	return TRUE;
}

//*******************************************************************
// ̑
//*******************************************************************
