#pragma once
#include <string>

class CConState
{
private:
	const static int STATE_NOT_INITIALIZED = -2;
	const static int STATE_FIXED = -1;
	int m_state;
	std::wstring m_name;

public:
	CConState(void)
		: m_state(STATE_NOT_INITIALIZED)
		{}
	~CConState(void)
		{}

	void SetFix()
		{ m_state = STATE_FIXED; }
	bool IsFix()
		{ return m_state == STATE_FIXED; }

	void SetOrigState(int s)
		{ m_state = s; }
	int GetOrigState()
		{ return m_state; }

	void SetOrigName(LPCWSTR name)
		{ m_name = name; }
	LPCWSTR GetOrigName()
		{ return m_name.c_str(); }

	bool IsIdling()
		{ return m_state != STATE_NOT_INITIALIZED; }
};
