#pragma once
#include "..\nsmsgs\nsmplugin.h"
#include "IdleSettings.h"
#include "ConState.h"
#include "etc.h"

//************************************************:

typedef BOOL (*HookFunc)();

//************************************************:

class CIdlePlugin :
	public CNsmPlugin
{
// Singleton -->
private:
	static CIdlePlugin m_singleton;

private:
	CIdlePlugin(void);
public:
	~CIdlePlugin(void);

public:
	static CIdlePlugin& GetInstance()
	{
		return m_singleton;
	}
// <-- Singleton

private:
	typedef std::map<HNsmConnection, CConState> ConStateMap;

private:
	// hook.dll ֘Ã|C^
	HMODULE m_hHookDll;
	int* m_hookHitCount;
//	BOOL* m_isFullScreen;
	HookFunc SetHook;
	HookFunc UnsetHook;

	UINT_PTR m_hTimer;
	UINT m_timerCount;
	bool m_bEnable;
	bool m_bFullScr;
	ConStateMap m_cons;

public:
	DEFINE_SERVICE1(ShowOptionDialog, HWND);
	DEFINE_SERVICE0(GetIdleTime);
	DEFINE_SERVICE0(IsIdling);
	DEFINE_SERVICE0(IsFullScreen);

	DEFINE_EVENTHOOK2(ConInfoChange, HNsmConnection, PNsmConnectionInfo);

private:
	// T[rX
	int DoShowOptionDialog(HWND hWnd);
	int DoGetIdleTime(void);
	int DoIsIdling(void);
	int DoIsFullScreen(void);

	// CxgtbN
	int OnConInfoChange(HNsmConnection hCon, PNsmConnectionInfo pnci);

	// 
	int LoadHookDll();
	VOID FreeHookDll();
	VOID Enable();
	VOID Disable();
	VOID SetTimer();
	VOID KillTimer();

	// C
	VOID OnTimer();
	void IdleCheck();
	bool IsFullScreen() const;

	void EnterFullScreen();
	void ConEnterFullScreen(HNsmConnection hCon, int nState);

	VOID IdleBegin(const ConditionInfo* pci);
	VOID ConIdleBegin(const ConditionInfo* pci, HNsmConnection hConnection);

	VOID StateEnd();
	VOID ConStateEnd(HNsmConnection hConnection);

	bool IsUserActive() const
	{ return *m_hookHitCount != 0; }
	void ResetUserActive()
	{ *m_hookHitCount = 0; }
	bool IsDllLoadSuccess() const
	{ return m_hHookDll != NULL; }

private:
	static void SaveNameChange(HNsmConnection hCon, LPCWSTR origName, LPCWSTR newName);
	static void DeleteNameChangeRecord(HNsmConnection hCon);
	static void RestoreNameChange(HNsmConnection hCon);
	static void SaveOrig(HNsmConnection hCon, CConState &s);
	static bool GetIdleUserName(std::wstring* out, LPCWSTR name, LPCWSTR str, int pos);
	static void SetUserName(HNsmConnection hCon, LPCWSTR name);
	static void SetUserStatus(HNsmConnection hCon, int nStatus);

	static bool IsWindowFullScreen(HWND hWnd, const RECT* pDesktopRect);

// R[obN֐
private:
	static VOID CALLBACK TimerProc(HWND hWnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime);

// I[o[Ch
public:
	int OnInitialize();
	void OnTerminate();
	int OnSystemModulesLoaded();
};

