#include "StdAfx.h"
#include ".\optiondlg.h"
#include "AddDlg.h"
#include "ProtoDlg.h"
#include "resource.h"
#include "cs_conv.h"

#define ONE_MINUTES	60

enum{
	CL_NO_IDLE,
	CL_NO_STATE,
	CL_NO_POS,
	CL_NO_STR,
	NUM_OF_COLUMN
};

//*******************************************************************
// RXgN^EfXgN^
//*******************************************************************
COptionDlg::COptionDlg(void)
: CDlg(IDD_OPTION)
{
}

COptionDlg::~COptionDlg(void)
{
}

//*******************************************************************
// I[o[Ch
//*******************************************************************
BOOL COptionDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		HANDLE_CMD(IDC_ENABLE, OnClickEnable());
		HANDLE_CMD(IDC_ADD, OnClickAdd());
		HANDLE_CMD(IDC_DELETE, OnClickDelete());
		HANDLE_CMD(IDC_SET, OnClickSet());
		HANDLE_CMD(IDC_EDIT, OnClickEdit());
		default:
			return FALSE;
		}
		return TRUE;

	case WM_NOTIFY:
		if( wParam == IDC_PROFILES ){
			switch( ((LPNMHDR)lParam)->code ){
			HANDLE_CMD(NM_DBLCLK, OnListDblClick());
			default:
				return FALSE;
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL COptionDlg::InitDlgCtrl()
{
	// ̃vOC𗘗p
	SetCheck(IDC_ENABLE, m_bEnable);
	EnableAll(m_bEnable);

	// IĈ
	SetCheck(IDC_ONLINE_ONLY, m_bOnlineOnly);

	// OA
	SetCheck(IDC_RECOVER_NAME, m_bEnableRecoverName);

	// tXN[Ǝ̏
	SetCombo(IDC_FULL_STATE, STATUS_STRINGS, STATUS_STRINGS_NUM, m_nFullScrState);

	// ΏۃvgR
	UpdateEnables();

	// Xg
	m_lv.SetWndHandle(GetDlgItem(IDC_CONDS));
	m_lv.SetExViewStyle(LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_LABELTIP);
	m_lv.AddColumn(CL_NO_IDLE, LVCFMT_RIGHT, "", 50);
	m_lv.AddColumn(CL_NO_STATE, LVCFMT_LEFT, "", 50);
	m_lv.AddColumn(CL_NO_POS, LVCFMT_LEFT, "O", 50);
	m_lv.AddColumn(CL_NO_STR, LVCFMT_LEFT, "", 200);

	UpdateList();

	return TRUE;
}

BOOL COptionDlg::GetDlgCtrlValue()
{
	m_bEnable = GetCheck(IDC_ENABLE);
	m_bEnableRecoverName = GetCheck(IDC_RECOVER_NAME);
	m_nFullScrState = GetComboCurSel(IDC_FULL_STATE, 0);
	m_bOnlineOnly = GetCheck(IDC_ONLINE_ONLY);

	return TRUE;
}

//*******************************************************************
// Cxgnh
//*******************************************************************
void COptionDlg::OnClickEdit()
{
	CProtoDlg dlg;

	dlg.SetEnableProtocols(&m_enables);
	if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
		UpdateEnables();
	}
}

void COptionDlg::OnClickEnable()
{
	EnableAll(GetCheck(IDC_ENABLE));
}

void COptionDlg::OnClickAdd()
{
	CAddDlg dlg;
	ConditionInfo* pInfo = new ConditionInfo;

	pInfo->nIdle = 300;
	pInfo->nState = 0;
	pInfo->nPos = 0;
	dlg.SetInfo(pInfo);

	if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
		m_pCond->push_back(pInfo);
		UpdateList();

		m_lv.SelectItem(m_pCond->size() - 1);
	}else{
		delete pInfo;
	}
}

void COptionDlg::OnClickDelete()
{
	ConditionInfo* pInfo;
	unsigned int iSel = m_lv.GetCurSel();
	
	if( iSel < m_pCond->size() ){
		pInfo = (*m_pCond)[iSel];
		m_pCond->erase(m_pCond->begin() + iSel);
		delete pInfo;

		UpdateList();
		if( iSel == m_pCond->size() )
			iSel--;
		m_lv.SelectItem(iSel);
	}
}

void COptionDlg::OnClickSet()
{
	EditSelectedItem();
}

void COptionDlg::OnListDblClick()
{
	EditSelectedItem();
}

//*******************************************************************
// ̑
//*******************************************************************
void COptionDlg::EditSelectedItem()
{
	ConditionInfo* pInfo;
	unsigned int iSel = m_lv.GetCurSel();
	
	if( iSel < m_pCond->size() ){
		CAddDlg dlg;

		pInfo = (*m_pCond)[iSel];
		dlg.SetInfo(pInfo);

		if( dlg.DoModal(m_hInstance, m_hDlgWnd) == IDOK ){
			UpdateList();
			m_lv.SelectItem(iSel);
		}
	}
}

void COptionDlg::EnableAll(BOOL bEnable)
{
	SetEnable(IDC_ONLINE_ONLY, bEnable);
	SetEnable(IDC_FULL_STATE, bEnable);
	SetEnable(IDC_EDIT, bEnable);
	SetEnable(IDC_CONDS, bEnable);
	SetEnable(IDC_ADD, bEnable);
	SetEnable(IDC_DELETE, bEnable);
	SetEnable(IDC_TOGGLE, bEnable);
}

void COptionDlg::UpdateList()
{
	int iItem;
	char buf[16];
	CondList::const_iterator i;
	std::string str;

	m_lv.ClearAllItem();

	iItem = 0;
	for( i = m_pCond->begin(); i != m_pCond->end(); ++i ){
		const ConditionInfo &ci = **i;
		::UnicodeToSJIS(ci.str.c_str(), str);
		_itoa_s((ci.nIdle/60), buf, 10),
		m_lv.InsertItemLine(iItem, NUM_OF_COLUMN,
			buf,
			STATUS_STRINGS[ci.nState+1],
			POS_STRINGS[ci.nPos],
			str.c_str());
		iItem++;
	}

	m_lv.AutosizeColumn(NUM_OF_COLUMN);
}

void COptionDlg::UpdateEnables()
{
	int i, last;
	std::string enables;

	for( i = 0, last = m_enables.size(); i < last; ++i ){
		if( i != 0 ) enables += ", ";
		enables += m_enables[i];
	}
	SetItemText(IDC_ENABLES, enables.c_str());
}
