#include "StdAfx.h"
#include ".\protodlg.h"
#include "resource.h"
#include "CommonService.h"

//*******************************************************************
// 
//*******************************************************************

CProtoDlg::CProtoDlg(void)
: CDlg(IDD_PROTO_SET)
{
}

CProtoDlg::~CProtoDlg(void)
{
}

//*******************************************************************
// 
//*******************************************************************

BOOL CProtoDlg::DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_NOTIFY:
		if( LOWORD(wParam) == IDC_TARGET ){
			switch( ((LPNMHDR)lParam)->code ){
			case NM_CLICK:
				OnListClick();
				break;
			default:
				return FALSE;
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CProtoDlg::InitDlgCtrl()
{
	CCommonService::protocol_list plist;
	StringList::iterator str;
	int ed;

	m_lv.SetWndHandle(GetDlgItem(IDC_TARGET));
	m_lv.SetExViewStyle(LVS_EX_FULLROWSELECT|LVS_EX_CHECKBOXES|LVS_EX_LABELTIP);
	m_lv.AddColumn(0, LVCFMT_LEFT, "", 100);

	NSM_SERVICE.GetProtocolList(plist);
	ed = plist.size();
	for( int i = 0; i < ed; ++i ){
		m_lv.InsertItem(i, plist[i].c_str());
		for( str = m_pEnables->begin(); str != m_pEnables->end(); ++str ){
			if( plist[i] == *str ){
				m_lv.SetCheck(i, true);
				break;
			}
		}
	}
	m_lv.AutosizeColumn(1);

	return TRUE;
}

BOOL CProtoDlg::GetDlgCtrlValue()
{
	int ed;
	char buf[256];

	m_pEnables->clear();
	ed = m_lv.GetItemCount();
	for( int i = 0; i < ed; ++i ){
		if( m_lv.GetCheck(i) ){
			m_lv.GetItemText(i, 0, buf, sizeof(buf));
			m_pEnables->push_back(buf);
		}
	}

	return TRUE;
}

//*******************************************************************
// 
//*******************************************************************

void CProtoDlg::OnListClick()
{
	int iSel = m_lv.GetCurSel();
	bool bEnable = m_lv.GetCheck(iSel);
	m_lv.SetCheck(iSel, !bEnable);
}
